﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using CommonContracts;
using System.ServiceModel;

namespace DemoClientApp
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Title = "示例客户端";

            using (ChannelFactory<IDemo> factory = new ChannelFactory<IDemo>("test_ep"))
            {
                IDemo channel = factory.CreateChannel();
                try
                {
                    double r = channel.SQR(-1.3d);
                    Console.WriteLine($"计算结果：{r}");
                }
                catch(FaultException<ErrorData> fault)
                {
                    string rs = fault.Reason.GetMatchingTranslation().Text;
                    ErrorData data = fault.Detail;
                    Console.WriteLine($"错误概要：{rs}");
                    Console.WriteLine($"发生错误的参数：{data.ArgName}\n错误的值：{data.ErrorVal}\n发生错误的操作：{data.CalledAction}");
                }

                Console.Read();
            }
        }
    }

}
