﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ServiceModel;
using CommonContracts;

namespace DemoServiceApp
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Title = "示例服务器";

            using (ServiceHost host = new ServiceHost(typeof(DemoService)))
            {
                host.Opened += (f, k) => Console.WriteLine("服务已启动。");

                host.Open();

                Console.Read();
            }
        }
    }

    internal class DemoService : IDemo
    {
        public double SQR(double input)
        {
            if (input <= 0d)
            {
                ErrorData erdata = new ErrorData
                {
                    ArgName = nameof(input),
                    ErrorVal = input,
                    CalledAction = OperationContext.Current.IncomingMessageHeaders.Action
                };
                throw new FaultException<ErrorData>(erdata, "参数必须大于0");
            }
            return input * input;
        }
    }

}
